The zxdg_toplevel_v6 interface

This interface defines an xdg_surface role which allows a surface to, among other things, set window-like properties such as maximize, fullscreen, and minimize, set application-specific metadata like title and id, and well as trigger user interactive operations such as interactive resize and move. More...

## Data Structures

struct | zxdg_toplevel_v6_listener

## Macros

#define | ZXDG_TOPLEVEL_V6_CONFIGURE_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_CLOSE_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_DESTROY_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_SET_PARENT_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_SET_TITLE_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_SET_APP_ID_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_SHOW_WINDOW_MENU_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_MOVE_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_RESIZE_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_SET_MAX_SIZE_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_SET_MIN_SIZE_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_SET_MAXIMIZED_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_UNSET_MAXIMIZED_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_SET_FULLSCREEN_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_UNSET_FULLSCREEN_SINCE_VERSION 1
#define | ZXDG_TOPLEVEL_V6_SET_MINIMIZED_SINCE_VERSION 1

## Enumerations

enum

zxdg_toplevel_v6_resize_edge {
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_NONE = 0,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP = 1,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM = 2,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_LEFT = 4,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP_LEFT = 5,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM_LEFT = 6,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_RIGHT = 8,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP_RIGHT = 9,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM_RIGHT = 10
}

enum | zxdg_toplevel_v6_state { ZXDG_TOPLEVEL_V6_STATE_MAXIMIZED = 1, ZXDG_TOPLEVEL_V6_STATE_FULLSCREEN = 2, ZXDG_TOPLEVEL_V6_STATE_RESIZING = 3, ZXDG_TOPLEVEL_V6_STATE_ACTIVATED = 4 }

## Functions

static int | zxdg_toplevel_v6_add_listener (struct zxdg_toplevel_v6 *zxdg_toplevel_v6, const struct zxdg_toplevel_v6_listener *listener, void *data)
static void | zxdg_toplevel_v6_set_user_data (struct zxdg_toplevel_v6 *zxdg_toplevel_v6, void *user_data)
static void * | zxdg_toplevel_v6_get_user_data (struct zxdg_toplevel_v6 *zxdg_toplevel_v6)
static void | zxdg_toplevel_v6_destroy (struct zxdg_toplevel_v6 *zxdg_toplevel_v6)
static void | zxdg_toplevel_v6_set_parent (struct zxdg_toplevel_v6 *zxdg_toplevel_v6, struct zxdg_toplevel_v6 *parent)
static void | zxdg_toplevel_v6_set_title (struct zxdg_toplevel_v6 *zxdg_toplevel_v6, const char *title)
static void | zxdg_toplevel_v6_set_app_id (struct zxdg_toplevel_v6 *zxdg_toplevel_v6, const char *app_id)
static void | zxdg_toplevel_v6_show_window_menu (struct zxdg_toplevel_v6 *zxdg_toplevel_v6, struct wl_seat *seat, uint32_t serial, int32_t x, int32_t y)
static void | zxdg_toplevel_v6_move (struct zxdg_toplevel_v6 *zxdg_toplevel_v6, struct wl_seat *seat, uint32_t serial)
static void | zxdg_toplevel_v6_resize (struct zxdg_toplevel_v6 *zxdg_toplevel_v6, struct wl_seat *seat, uint32_t serial, uint32_t edges)
static void | zxdg_toplevel_v6_set_max_size (struct zxdg_toplevel_v6 *zxdg_toplevel_v6, int32_t width, int32_t height)
static void | zxdg_toplevel_v6_set_min_size (struct zxdg_toplevel_v6 *zxdg_toplevel_v6, int32_t width, int32_t height)
static void | zxdg_toplevel_v6_set_maximized (struct zxdg_toplevel_v6 *zxdg_toplevel_v6)
static void | zxdg_toplevel_v6_unset_maximized (struct zxdg_toplevel_v6 *zxdg_toplevel_v6)
static void | zxdg_toplevel_v6_set_fullscreen (struct zxdg_toplevel_v6 *zxdg_toplevel_v6, struct wl_output *output)
static void | zxdg_toplevel_v6_unset_fullscreen (struct zxdg_toplevel_v6 *zxdg_toplevel_v6)
static void | zxdg_toplevel_v6_set_minimized (struct zxdg_toplevel_v6 *zxdg_toplevel_v6)

## Detailed Description

This interface defines an xdg_surface role which allows a surface to, among other things, set window-like properties such as maximize, fullscreen, and minimize, set application-specific metadata like title and id, and well as trigger user interactive operations such as interactive resize and move.

## Macro Definition Documentation

## ZXDG_TOPLEVEL_V6_CLOSE_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_CLOSE_SINCE_VERSION 1

Definition at line 1131 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_CONFIGURE_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_CONFIGURE_SINCE_VERSION 1

Definition at line 1127 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_DESTROY_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_DESTROY_SINCE_VERSION 1

Definition at line 1136 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_MOVE_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_MOVE_SINCE_VERSION 1

Definition at line 1156 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_RESIZE_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_RESIZE_SINCE_VERSION 1

Definition at line 1160 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_SET_APP_ID_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_SET_APP_ID_SINCE_VERSION 1

Definition at line 1148 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_SET_FULLSCREEN_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_SET_FULLSCREEN_SINCE_VERSION 1

Definition at line 1180 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_SET_MAX_SIZE_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_SET_MAX_SIZE_SINCE_VERSION 1

Definition at line 1164 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_SET_MAXIMIZED_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_SET_MAXIMIZED_SINCE_VERSION 1

Definition at line 1172 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_SET_MIN_SIZE_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_SET_MIN_SIZE_SINCE_VERSION 1

Definition at line 1168 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_SET_MINIMIZED_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_SET_MINIMIZED_SINCE_VERSION 1

Definition at line 1188 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_SET_PARENT_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_SET_PARENT_SINCE_VERSION 1

Definition at line 1140 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_SET_TITLE_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_SET_TITLE_SINCE_VERSION 1

Definition at line 1144 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_SHOW_WINDOW_MENU_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_SHOW_WINDOW_MENU_SINCE_VERSION 1

Definition at line 1152 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_UNSET_FULLSCREEN_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_UNSET_FULLSCREEN_SINCE_VERSION 1

Definition at line 1184 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_TOPLEVEL_V6_UNSET_MAXIMIZED_SINCE_VERSION

#define ZXDG_TOPLEVEL_V6_UNSET_MAXIMIZED_SINCE_VERSION 1

Definition at line 1176 of file xdg-shell-unstable-v6-client-protocol.h.

## Enumeration Type Documentation

## zxdg_toplevel_v6_resize_edge

enum zxdg_toplevel_v6_resize_edge

edge values for resizing

These values are used to indicate which edge of a surface is being dragged in a resize operation.

Enumerator
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_NONE |
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP |
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM |
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_LEFT |
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP_LEFT |
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM_LEFT |
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_RIGHT |
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP_RIGHT |
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM_RIGHT |

Definition at line 1004 of file xdg-shell-unstable-v6-client-protocol.h.

{
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_NONE = 0,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP = 1,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM = 2,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_LEFT = 4,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP_LEFT = 5,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM_LEFT = 6,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_RIGHT = 8,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP_RIGHT = 9,
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM_RIGHT = 10,
};

## zxdg_toplevel_v6_state

enum zxdg_toplevel_v6_state

the surface is now activated

Client window decorations should be painted as if the window is active. Do not assume this means that the window actually has keyboard or pointer focus.

Enumerator
ZXDG_TOPLEVEL_V6_STATE_MAXIMIZED | the surface is maximized
ZXDG_TOPLEVEL_V6_STATE_FULLSCREEN | the surface is fullscreen
ZXDG_TOPLEVEL_V6_STATE_RESIZING | the surface is being resized
ZXDG_TOPLEVEL_V6_STATE_ACTIVATED | the surface is now activated

Definition at line 1027 of file xdg-shell-unstable-v6-client-protocol.h.

{
/**
* the surface is maximized
*/
ZXDG_TOPLEVEL_V6_STATE_MAXIMIZED = 1,
/**
* the surface is fullscreen
*/
ZXDG_TOPLEVEL_V6_STATE_FULLSCREEN = 2,
/**
* the surface is being resized
*/
ZXDG_TOPLEVEL_V6_STATE_RESIZING = 3,
/**
* the surface is now activated
*/
ZXDG_TOPLEVEL_V6_STATE_ACTIVATED = 4,
};

## Function Documentation

## zxdg_toplevel_v6_add_listener()

static int zxdg_toplevel_v6_add_listener | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6,
|  | const struct zxdg_toplevel_v6_listener * | listener,
|  | void * | data
| ) |  |

inline static

Definition at line 1102 of file xdg-shell-unstable-v6-client-protocol.h.

{
return wl_proxy_add_listener((struct wl_proxy *) zxdg_toplevel_v6,
(void (**)(void)) listener, data);
}

## zxdg_toplevel_v6_destroy()

static void zxdg_toplevel_v6_destroy | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6 | ) |

inline static

Unmap and destroy the window. The window will be effectively hidden from the user's point of view, and all state like maximization, fullscreen, and so on, will be lost.

Definition at line 1218 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_DESTROY);
wl_proxy_destroy((struct wl_proxy *) zxdg_toplevel_v6);
}

References ZXDG_TOPLEVEL_V6_DESTROY.

## zxdg_toplevel_v6_get_user_data()

static void* zxdg_toplevel_v6_get_user_data | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6 | ) |

inline static

Definition at line 1199 of file xdg-shell-unstable-v6-client-protocol.h.

{
return wl_proxy_get_user_data((struct wl_proxy *) zxdg_toplevel_v6);
}

## zxdg_toplevel_v6_move()

static void zxdg_toplevel_v6_move | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6,
|  | struct wl_seat * | seat,
|  | uint32_t | serial
| ) |  |

inline static

Start an interactive, user-driven move of the surface.

This request must be used in response to some sort of user action like a button press, key press, or touch down event. The passed serial is used to determine the type of interactive move (touch, pointer, etc).

The server may ignore move requests depending on the state of the surface (e.g. fullscreen or maximized), or if the passed serial is no longer valid.

If triggered, the surface will lose the focus of the device (wl_pointer, wl_touch, etc) used for the move. It is up to the compositor to visually indicate that the move is taking place, such as updating a pointer cursor, during the move. There is no guarantee that the device focus will return when the move is completed.

Definition at line 1336 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_MOVE, seat, serial);
}

References ZXDG_TOPLEVEL_V6_MOVE.

## zxdg_toplevel_v6_resize()

static void zxdg_toplevel_v6_resize | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6,
|  | struct wl_seat * | seat,
|  | uint32_t | serial,
|  | uint32_t | edges
| ) |  |

inline static

Start a user-driven, interactive resize of the surface.

This request must be used in response to some sort of user action like a button press, key press, or touch down event. The passed serial is used to determine the type of interactive resize (touch, pointer, etc).

The server may ignore resize requests depending on the state of the surface (e.g. fullscreen or maximized).

If triggered, the client will receive configure events with the "resize" state enum value and the expected sizes. See the "resize" enum value for more details about what is required. The client must also acknowledge configure events using "ack_configure". After the resize is completed, the client will receive another "configure" event without the resize state.

If triggered, the surface also will lose the focus of the device (wl_pointer, wl_touch, etc) used for the resize. It is up to the compositor to visually indicate that the resize is taking place, such as updating a pointer cursor, during the resize. There is no guarantee that the device focus will return when the resize is completed.

The edges parameter specifies how the surface should be resized, and is one of the values of the resize_edge enum. The compositor may use this information to update the surface position for example when dragging the top left corner. The compositor may also use this information to adapt its behavior, e.g. choose an appropriate cursor image.

Definition at line 1377 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_RESIZE, seat, serial, edges);
}

References ZXDG_TOPLEVEL_V6_RESIZE.

## zxdg_toplevel_v6_set_app_id()

static void zxdg_toplevel_v6_set_app_id | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6,
|  | const char * | app_id
| ) |  |

inline static

Set an application identifier for the surface.

The app ID identifies the general class of applications to which the surface belongs. The compositor can use this to group multiple surfaces together, or to determine how to launch a new application.

For D-Bus activatable applications, the app ID is used as the D-Bus service name.

The compositor shell will try to group application surfaces together by their app ID. As a best practice, it is suggested to select app ID's that match the basename of the application's .desktop file. For example, "org.freedesktop.FooViewer" where the .desktop file is "org.freedesktop.FooViewer.desktop".

See the desktop-entry specification [0] for more details on application identifiers and how they relate to well-known D-Bus names and .desktop files.

[0] http://standards.freedesktop.org/desktop-entry-spec/

Definition at line 1287 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_SET_APP_ID, app_id);
}

References ZXDG_TOPLEVEL_V6_SET_APP_ID.

## zxdg_toplevel_v6_set_fullscreen()

static void zxdg_toplevel_v6_set_fullscreen | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6,
|  | struct wl_output * | output
| ) |  |

inline static

Make the surface fullscreen.

You can specify an output that you would prefer to be fullscreen. If this value is NULL, it's up to the compositor to choose which display will be used to map this surface.

If the surface doesn't cover the whole output, the compositor will position the surface in the center of the output and compensate with black borders filling the rest of the output.

Definition at line 1542 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_SET_FULLSCREEN, output);
}

References sort_controllers::output, and ZXDG_TOPLEVEL_V6_SET_FULLSCREEN.

## zxdg_toplevel_v6_set_max_size()

static void zxdg_toplevel_v6_set_max_size | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6,
|  | int32_t | width,
|  | int32_t | height
| ) |  |

inline static

Set a maximum size for the window.

The client can specify a maximum size so that the compositor does not try to configure the window beyond this size.

The width and height arguments are in window geometry coordinates. See xdg_surface.set_window_geometry.

Values set in this way are double-buffered. They will get applied on the next commit.

The compositor can use this information to allow or disallow different states like maximize or fullscreen and draw accurate animations.

Similarly, a tiling window manager may use this information to place and resize client windows in a more effective way.

The client should not rely on the compositor to obey the maximum size. The compositor may decide to ignore the values set by the client and request a larger size.

If never set, or a value of zero in the request, means that the client has no expected maximum size in the given dimension. As a result, a client wishing to reset the maximum size to an unspecified state can use zero for width and height in the request.

Requesting a maximum size to be smaller than the minimum size of a surface is illegal and will result in a protocol error.

The width and height must be greater than or equal to zero. Using strictly negative values for width and height will result in a protocol error.

Definition at line 1422 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_SET_MAX_SIZE, width, height);
}

References ZXDG_TOPLEVEL_V6_SET_MAX_SIZE.

## zxdg_toplevel_v6_set_maximized()

static void zxdg_toplevel_v6_set_maximized | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6 | ) |

inline static

Maximize the surface.

After requesting that the surface should be maximized, the compositor will respond by emitting a configure event with the "maximized" state and the required window geometry. The client should then update its content, drawing it in a maximized state, i.e. without shadow or other decoration outside of the window geometry. The client must also acknowledge the configure when committing the new content (see ack_configure).

It is up to the compositor to decide how and where to maximize the surface, for example which output and what region of the screen should be used.

If the surface was already maximized, the compositor will still emit a configure event with the "maximized" state.

Definition at line 1494 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_SET_MAXIMIZED);
}

References ZXDG_TOPLEVEL_V6_SET_MAXIMIZED.

## zxdg_toplevel_v6_set_min_size()

static void zxdg_toplevel_v6_set_min_size | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6,
|  | int32_t | width,
|  | int32_t | height
| ) |  |

inline static

Set a minimum size for the window.

The client can specify a minimum size so that the compositor does not try to configure the window below this size.

The width and height arguments are in window geometry coordinates. See xdg_surface.set_window_geometry.

Values set in this way are double-buffered. They will get applied on the next commit.

The compositor can use this information to allow or disallow different states like maximize or fullscreen and draw accurate animations.

Similarly, a tiling window manager may use this information to place and resize client windows in a more effective way.

The client should not rely on the compositor to obey the minimum size. The compositor may decide to ignore the values set by the client and request a smaller size.

If never set, or a value of zero in the request, means that the client has no expected minimum size in the given dimension. As a result, a client wishing to reset the minimum size to an unspecified state can use zero for width and height in the request.

Requesting a minimum size to be larger than the maximum size of a surface is illegal and will result in a protocol error.

The width and height must be greater than or equal to zero. Using strictly negative values for width and height will result in a protocol error.

Definition at line 1467 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_SET_MIN_SIZE, width, height);
}

References ZXDG_TOPLEVEL_V6_SET_MIN_SIZE.

## zxdg_toplevel_v6_set_minimized()

static void zxdg_toplevel_v6_set_minimized | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6 | ) |

inline static

Request that the compositor minimize your surface. There is no way to know if the surface is currently minimized, nor is there any way to unset minimization on this surface.

If you are looking to throttle redrawing when minimized, please instead use the wl_surface.frame event for this, as this will also work with live previews on windows in Alt-Tab, Expose or similar compositor features.

Definition at line 1571 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_SET_MINIMIZED);
}

References ZXDG_TOPLEVEL_V6_SET_MINIMIZED.

## zxdg_toplevel_v6_set_parent()

static void zxdg_toplevel_v6_set_parent | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6,
|  | struct zxdg_toplevel_v6 * | parent
| ) |  |

inline static

Set the "parent" of this surface. This window should be stacked above a parent. The parent surface must be mapped as long as this surface is mapped.

Parent windows should be set on dialogs, toolboxes, or other "auxiliary" surfaces, so that the parent is raised when the dialog is raised.

Definition at line 1238 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_SET_PARENT, parent);
}

References ZXDG_TOPLEVEL_V6_SET_PARENT.

## zxdg_toplevel_v6_set_title()

static void zxdg_toplevel_v6_set_title | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6,
|  | const char * | title
| ) |  |

inline static

Set a short title for the surface.

This string may be used to identify the surface in a task bar, window list, or other user interface elements provided by the compositor.

The string must be encoded in UTF-8.

Definition at line 1256 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_SET_TITLE, title);
}

References ZXDG_TOPLEVEL_V6_SET_TITLE.

## zxdg_toplevel_v6_set_user_data()

static void zxdg_toplevel_v6_set_user_data | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6,
|  | void * | user_data
| ) |  |

inline static

Definition at line 1192 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_set_user_data((struct wl_proxy *) zxdg_toplevel_v6, user_data);
}

## zxdg_toplevel_v6_show_window_menu()

static void zxdg_toplevel_v6_show_window_menu | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6,
|  | struct wl_seat * | seat,
|  | uint32_t | serial,
|  | int32_t | x,
|  | int32_t | y
| ) |  |

inline static

Clients implementing client-side decorations might want to show a context menu when right-clicking on the decorations, giving the user a menu that they can use to maximize or minimize the window.

This request asks the compositor to pop up such a window menu at the given position, relative to the local surface coordinates of the parent surface. There are no guarantees as to what menu items the window menu contains.

This request must be used in response to some sort of user action like a button press, key press, or touch down event.

Definition at line 1309 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_SHOW_WINDOW_MENU, seat, serial, x, y);
}

References ZXDG_TOPLEVEL_V6_SHOW_WINDOW_MENU.

## zxdg_toplevel_v6_unset_fullscreen()

static void zxdg_toplevel_v6_unset_fullscreen | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6 | ) |

inline static

Definition at line 1552 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_UNSET_FULLSCREEN);
}

References ZXDG_TOPLEVEL_V6_UNSET_FULLSCREEN.

## zxdg_toplevel_v6_unset_maximized()

static void zxdg_toplevel_v6_unset_maximized | ( | struct zxdg_toplevel_v6 * | zxdg_toplevel_v6 | ) |

inline static

Unmaximize the surface.

After requesting that the surface should be unmaximized, the compositor will respond by emitting a configure event without the "maximized" state. If available, the compositor will include the window geometry dimensions the window had prior to being maximized in the configure request. The client must then update its content, drawing it in a regular state, i.e. potentially with shadow, etc. The client must also acknowledge the configure when committing the new content (see ack_configure).

It is up to the compositor to position the surface after it was unmaximized; usually the position the surface had before maximizing, if applicable.

If the surface was already not maximized, the compositor will still emit a configure event without the "maximized" state.

Definition at line 1522 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_toplevel_v6,
ZXDG_TOPLEVEL_V6_UNSET_MAXIMIZED);
}

References ZXDG_TOPLEVEL_V6_UNSET_MAXIMIZED.

ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP_LEFT
@ ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP_LEFT
Definition: xdg-shell-unstable-v6-client-protocol.h:1009
ZXDG_TOPLEVEL_V6_SET_APP_ID
#define ZXDG_TOPLEVEL_V6_SET_APP_ID
Definition: xdg-shell-unstable-v6-client-protocol.h:1112
ZXDG_TOPLEVEL_V6_SET_MINIMIZED
#define ZXDG_TOPLEVEL_V6_SET_MINIMIZED
Definition: xdg-shell-unstable-v6-client-protocol.h:1122
ZXDG_TOPLEVEL_V6_SET_MAX_SIZE
#define ZXDG_TOPLEVEL_V6_SET_MAX_SIZE
Definition: xdg-shell-unstable-v6-client-protocol.h:1116
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP
@ ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP
Definition: xdg-shell-unstable-v6-client-protocol.h:1006
width
GLint GLint GLsizei width
Definition: SDL_opengl.h:1572
ZXDG_TOPLEVEL_V6_UNSET_FULLSCREEN
#define ZXDG_TOPLEVEL_V6_UNSET_FULLSCREEN
Definition: xdg-shell-unstable-v6-client-protocol.h:1121
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM_RIGHT
@ ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM_RIGHT
Definition: xdg-shell-unstable-v6-client-protocol.h:1013
ZXDG_TOPLEVEL_V6_SHOW_WINDOW_MENU
#define ZXDG_TOPLEVEL_V6_SHOW_WINDOW_MENU
Definition: xdg-shell-unstable-v6-client-protocol.h:1113
ZXDG_TOPLEVEL_V6_SET_FULLSCREEN
#define ZXDG_TOPLEVEL_V6_SET_FULLSCREEN
Definition: xdg-shell-unstable-v6-client-protocol.h:1120
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1974
ZXDG_TOPLEVEL_V6_SET_PARENT
#define ZXDG_TOPLEVEL_V6_SET_PARENT
Definition: xdg-shell-unstable-v6-client-protocol.h:1110
ZXDG_TOPLEVEL_V6_RESIZE
#define ZXDG_TOPLEVEL_V6_RESIZE
Definition: xdg-shell-unstable-v6-client-protocol.h:1115
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
ZXDG_TOPLEVEL_V6_STATE_ACTIVATED
@ ZXDG_TOPLEVEL_V6_STATE_ACTIVATED
Definition: xdg-shell-unstable-v6-client-protocol.h:1043
height
GLint GLint GLsizei GLsizei height
Definition: SDL_opengl.h:1572
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_RIGHT
@ ZXDG_TOPLEVEL_V6_RESIZE_EDGE_RIGHT
Definition: xdg-shell-unstable-v6-client-protocol.h:1011
ZXDG_TOPLEVEL_V6_STATE_FULLSCREEN
@ ZXDG_TOPLEVEL_V6_STATE_FULLSCREEN
Definition: xdg-shell-unstable-v6-client-protocol.h:1035
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_LEFT
@ ZXDG_TOPLEVEL_V6_RESIZE_EDGE_LEFT
Definition: xdg-shell-unstable-v6-client-protocol.h:1008
ZXDG_TOPLEVEL_V6_SET_MIN_SIZE
#define ZXDG_TOPLEVEL_V6_SET_MIN_SIZE
Definition: xdg-shell-unstable-v6-client-protocol.h:1117
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
ZXDG_TOPLEVEL_V6_SET_MAXIMIZED
#define ZXDG_TOPLEVEL_V6_SET_MAXIMIZED
Definition: xdg-shell-unstable-v6-client-protocol.h:1118
sort_controllers.output
output
Definition: sort_controllers.py:10
ZXDG_TOPLEVEL_V6_DESTROY
#define ZXDG_TOPLEVEL_V6_DESTROY
Definition: xdg-shell-unstable-v6-client-protocol.h:1109
ZXDG_TOPLEVEL_V6_STATE_MAXIMIZED
@ ZXDG_TOPLEVEL_V6_STATE_MAXIMIZED
Definition: xdg-shell-unstable-v6-client-protocol.h:1031
ZXDG_TOPLEVEL_V6_UNSET_MAXIMIZED
#define ZXDG_TOPLEVEL_V6_UNSET_MAXIMIZED
Definition: xdg-shell-unstable-v6-client-protocol.h:1119
ZXDG_TOPLEVEL_V6_STATE_RESIZING
@ ZXDG_TOPLEVEL_V6_STATE_RESIZING
Definition: xdg-shell-unstable-v6-client-protocol.h:1039
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_NONE
@ ZXDG_TOPLEVEL_V6_RESIZE_EDGE_NONE
Definition: xdg-shell-unstable-v6-client-protocol.h:1005
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM
@ ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM
Definition: xdg-shell-unstable-v6-client-protocol.h:1007
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP_RIGHT
@ ZXDG_TOPLEVEL_V6_RESIZE_EDGE_TOP_RIGHT
Definition: xdg-shell-unstable-v6-client-protocol.h:1012
ZXDG_TOPLEVEL_V6_MOVE
#define ZXDG_TOPLEVEL_V6_MOVE
Definition: xdg-shell-unstable-v6-client-protocol.h:1114
ZXDG_TOPLEVEL_V6_SET_TITLE
#define ZXDG_TOPLEVEL_V6_SET_TITLE
Definition: xdg-shell-unstable-v6-client-protocol.h:1111
ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM_LEFT
@ ZXDG_TOPLEVEL_V6_RESIZE_EDGE_BOTTOM_LEFT
Definition: xdg-shell-unstable-v6-client-protocol.h:1010